#!/bin/sh -a
# $Header: convert_ihand.sh,v 1.3 98/08/28 07:45:56 agilbert Exp $
########################################################################
#bcpyrght
#***************************************************************************
#* Copyright 1993 - 1998 VERITAS Software Corporation, All Rights Reserved *
#***************************************************************************
#ecpyrght
#########################################################################
#
# Purpose: In an HSM upgrade from pre-3.1 to 3.1+
#  ihand file formats need to be changed.
#
#  This script determines all hsmname areas,
#  makes a call to 'convert_ihand' utility (that converts .IHAND files),
#  then renames old IHAND file to <hsmname>.IHAND.pre_31,
#  and places the converted data into <hsmname>.IHAND
#########################################################################
ECHO=echo
## Make sure this is being run from root.
ISROOT=`/usr/bin/id | egrep "^uid=0\("`
if [ "${ISROOT}" = "" ] ; then
  ${ECHO} "
  This must be run while logged in as root."
  exit 1
fi

TMP=`pwd`
MV_IHAND="mv_IHAND.sh"

. /usr/openv/hsm/bin/migscriptcons

## get list of hsmnames
${GETHSM} 1> /tmp/Gethsm.err
 if [ $? != 0 ]; then
   ${ECHO} "** gethsm error: ** Aborted"
   if [ -f /tmp/Gethsm.err ]; then
    rm /tmp/Gethsm.err 2> /dev/null
   fi
   exit 1
 fi
 if [ -f /tmp/Gethsm.err ]; then
  rm /tmp/Gethsm.err 2> /dev/null
 fi

set `${GETHSM}` 
${ECHO} "#\!/bin/sh" > /tmp/$MV_IHAND
chmod u+x /tmp/$MV_IHAND
 ${ECHO}
 ${ECHO}  "<----------- Converting IHAND files ----------->"
 ${ECHO}

## loop thru set of hsmnames.
while [ x$1 != x ]
do
  # pick up a name from set
  HSMNAME=$1
  # get path to  hsmname database directory where ihand file is at.
  DBDIR=`${MIGDBDIR} $HSMNAME ${GET_DWPATH}`${DATABASE}
  if [ $? != 0 ]; then
     # log message MIGDBDIR failed
     ${ECHO} "$HSMNAME failed in MIGDBDIR"
     shift 1
     # try next hsmname in the list
     continue
  fi
  OldName=`${ECHO} "${DBDIR}/${HSMNAME}.IHAND"`
  ## actual convertionof ihand file
  NewName=`${HSMBINPATH}/convert_ihand $HSMNAME 2>/dev/null`
  if [ $? != 0 ]; then
     ${ECHO} "$1 convert_ihand failed "
     ${ECHO} $NewName	# Error:
     ${ECHO}  " try to fix error, then rerun [${HSMBINPATH}/convert_ihand $HSMNAME] by hand"
     ${ECHO}  "     <---------------------------->"
  else
    if [ -f ${OldName}.pre_31 ]; then
      ${ECHO} " Found existing ${OldName}.pre_31, moving to /tmp/${HSMNAME}.IHAND.pre_31.`date +'%m%d-%H%M'"
      mv ${OldName}.pre_31 /tmp/${HSMNAME}.IHAND.pre_31.`date -u +%m%d-%H%M`
    fi
    NewName=`echo $NewName | cut -d" " -f8`
    ${ECHO} "mv $OldName ${OldName}.pre_31" >> /tmp/$MV_IHAND 
    ${ECHO} "mv $NewName $OldName" >> /tmp/$MV_IHAND 
  fi
  shift 1
done

##  Rename OLD, Replace OLD w/ NEW
. /tmp/$MV_IHAND
rm /tmp/$MV_IHAND

# done converting all ihands.
${ECHO} ".... Done converting all ihand files."
${ECHO}
exit 0
